<template>
	<div>
		<div v-if="loading" class="loading-container">
			<v-progress-circular indeterminate :size="50" />
		</div>
		<template v-else>
			<div class="mb-10">
				<v-btn color="primary" to="/stocks">
					<v-icon left>mdi-arrow-left</v-icon>
					Back
				</v-btn>
			</div>
			<template v-if="stock">
				<h2 class="mb-10">{{ stock.name }}</h2>
				
				<div class="chart-container">
					<transition name="fade">
						<div v-show="chartLoading" class="loading-chart">
							<v-progress-circular indeterminate :size="100" />
						</div>
					</transition>
					<transition name="fade">
						<div v-show="!chartLoading" class="chart">
							<apexchart height="700" :options="chartOptions" :series="series" />
						</div>
					</transition>
				</div>
				
			</template>
			<template v-else>
				<h2 class="text-center">Stock with ticker "{{ $route.params.id }}" not found.</h2>
			</template>
		</template>
	</div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts';
import finnhubClient from '@/plugins/finnhubClient';
import { Stock } from '@/models/Stock';

export default {
	components: {
		apexchart: VueApexCharts,
	},
	data() {
		return {
			stock: null,
			loading: false,
			chartLoading: true,
			chartOptions: {
				chart: {
					type: 'candlestick',
					height: 500,
					selection: {
						enabled: false,
					},
					zoom: {
						enabled: false,
					},
					toolbar: {
						show: false,
					},
					animations: {
						enabled: false,
						dynamicAnimation: {
							enabled: true,
							speed: 10,
						}
					},
					events: {
						mounted(chartContext, config) {
							console.log('chart mounted');
							this.chartLoading = false;
						},
						updated: function(chartContext, config) {
							this.chartLoading = false;
						}
					},
				},
				xaxis: {
					type: 'datetime',
				},
				yaxis: {
					tooltip: {
						enabled: true,
					},
				},
			},
			series: [],
		};
	},
	created() {},
	computed: {
		allAvailableStocks() {
			return this.$store.getters['stocks/allAvailableStocks'];
		},
		stocks() {
			return this.$store.getters['stocks/stocks'];
		},
	},
	watch: {
		$route: {
			handler(to, from) {
				const ticker = to.params.id.toUpperCase();

				// Validation
				const foundInAvailable = this.allAvailableStocks.find((stock) => stock.symbol === ticker);
				if (!foundInAvailable) {
					return;
				}

				this.stock = new Stock(ticker);
				
				this.fetchCompanyData();
				this.fetchStockPrices();
			},
			immediate: true,
		},
	},
	methods: {
		fetchCompanyData() {
			const foundInStore = this.stocks.findByTicker(this.stock.ticker);

			if (foundInStore) {
				this.stock = foundInStore;
				return;
			}

			this.stock
				.fetch()
				.then(() => {
					this.stocks.add(this.stock, false);
				})
				.catch((e) => {
					console.log(e);
				});
		},
		fetchStockPrices() {
			if (this.stock.prices.length > 0) {
				this.series = [{ data: this.stock.prices }];
				this.chartLoading = false;
				return;
			}

			this.stock
				.fetchHistoryPrices()
				.then(() => {
					this.series = [{ data: this.stock.prices }];
					this.chartLoading = false;
				})
				.catch((e) => {
					console.log(e);
				});
		},
	},
};
</script>

<style lang="scss" scoped>
.loading-container {
	text-align: center;
}
.chart-container {
	position: relative;
	.loading-chart,
	.chart {
		position: absolute;
		top: 0;
		left: 0;
		right: 0;
	}
	.loading-chart {
		height: 715px;
		background-color: rgba(0, 0, 0, 0.02);
		display: flex;
		justify-content: center;
		align-items: center;
	}
}
.fade-enter-active, .fade-leave-active {
	transition: opacity .5s;
}
.fade-enter, .fade-leave-to {
	opacity: 0;
}
</style>
